import java.io.BufferedOutputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.util.HashMap;
import java.util.Vector;

/**
 * Yamaha SMAF format information.
 * @author qq379264347
 */
public class Smaf_mmf {
	/**
	 * ļȫ·
	 */
	private String fileName;
	/**
	 * ļͷ
	 */
	public static final String fileHeader = "MMMD";
	/**
	 * Ҫݿ
	 */
	public static final String noSkipTag = "MTR";
	/**
	 * ļݴС
	 */
	private int fileSize = 0;
	/**
	 * ݿ
	 */
	private HashMap<Integer, DataBlock> dataBlocks = new HashMap<>();
	/**
	 * ݿ
	 */
	private int nums;
	/**
	 * ʣֽ
	 */
	private byte[] lastBytes;

	public Smaf_mmf(String fileName) {
		this.fileName = fileName;
	}

	/**
	 * midļ
	 */
	public void chuli() throws Exception {
		//ƳMTR1/MTR2/MTR3/MTR4ݿ
		for (int i = 1; i <= nums; i++) {
			DataBlock db = dataBlocks.get(i);
			if (!db.getName().startsWith("MTR")) {
				//С
				fileSize -= 8; //ƺͳϢ8ֽ
				fileSize -= db.getDataSize(); //ݳ
				//Ƴݿ
				dataBlocks.remove(i);
			}
		}
		
		File file = new File(fileName);
		
		FileOutputStream out = new FileOutputStream(file.getParent() + "/!" + file.getName());
		BufferedOutputStream buffout = new BufferedOutputStream(out);
		DataOutputStream dataout = new DataOutputStream(buffout);
		
		dataout.write(fileHeader.getBytes("GBK")); //ļͷ
		dataout.writeInt(fileSize); //ܴС
		for (int i = 1; i <= nums; i++) {
			DataBlock db = dataBlocks.get(i);
			if (db != null) {
				dataout.write(db.getName().getBytes("GBK"));
				dataout.writeInt(db.getDataSize());
				dataout.write(db.getDatas());
			}
		}
		
		if (lastBytes != null) {
			dataout.write(lastBytes);
		}
		
		dataout.flush();
		buffout.flush();
		out.flush();
		
		dataout.close();
		buffout.close();
		out.close();
	}

	public int getFileSize() {
		return fileSize;
	}

	public void setFileSize(int fileSize) {
		this.fileSize = fileSize;
	}

	public HashMap<Integer, DataBlock> getDataBlocks() {
		return dataBlocks;
	}

	public void setDataBlocks(HashMap<Integer, DataBlock> dataBlocks) {
		this.dataBlocks = dataBlocks;
	}

	public static String getFileheader() {
		return fileHeader;
	}

	public static String getNoskiptag() {
		return noSkipTag;
	}

	public int getNums() {
		return nums;
	}

	public void setNums(int nums) {
		this.nums = nums;
	}

	public byte[] getLastBytes() {
		return lastBytes;
	}

	public void setLastBytes(byte[] lastBytes) {
		this.lastBytes = lastBytes;
	}

	/**
	 * strΪָȡһַ
	 * @param s
	 * @param str
	 * @return
	 */
	public static String getStartStr(String s, String str) {
		String[] str1 = chaifenstring(s, str);
		return str1[0];
	}

	/**
	 * strΪָȡһַ
	 * @param s
	 * @param str
	 * @return
	 */
	public static String getLastStr(String s, String str) {
		String[] str1 = chaifenstring(s, str);
		 return str1[str1.length - 1];
	}

	/**
	 * ַs1s2ָָ洢һάзأеַѾûs2ַˡ
	 * s2ֳɿַ""ԭַΪs2 + "" + s2
	 * s2ͷβɾͷβs1ٲ֡
	 * @param s1 ԭʼַ
	 * @param s2 ַ
	 * @return
	 */
	public static String[] chaifenstring(String s1, String s2) {
		if (s1 == null || s1.length() == 0) { //ջnullʱ򷵻һԪصһά
			return new String[]{""};
		}
		if (s1.endsWith(s2) || s1.startsWith(s2)) {
			//System.out.println("ַʧܣҪֵַԲַβͷ");
			//return null; //ֱӷnullܻᵼºĴȥ׺ٴַ顣
			s1 = delStr(s1, s2); //s2βͷȥѭ
		}
		
		Vector<String> vc = new Vector<String>();
		int m = 0;
		
		for (int i = s1.indexOf(s2); i < s1.length() && i != -1; i = s1.indexOf(s2, i + s2.length())) {
			String str = s1.substring(m, i);
			vc.addElement(str);
			m = i + s2.length();
		}
		vc.addElement(s1.substring(m));
		
		return vectorToString(vc);
	}

	/**
	 * VectorתString[]
	 * @param vector
	 * @return
	 */
	public static String[] vectorToString(Vector<String> vector) {
		String as[] = new String[vector.size()];
		for (int i = 0; i < as.length; i++) {
			as[i] = vector.elementAt(i);
		}
		return as; //һάַ
	}

	/**
	 * ȥַstrsͷsβ
	 * @param str
	 * @param s
	 * @return
	 */
	public static String delStr(String str, String s) {
		while(str.startsWith(s)) str = delStrBefore(str, s); //sͷȥѭ
		while(str.endsWith(s)) str = delStrAfter(str, s); //sβȥѭ
		return str;
	}

	/**
	 * ȥַǰ
	 * @param str Ҫַ
	 * @param s ҪȥĿͷַ
	 * @return strȥͷsַ
	 */
	public static String delStrBefore(String str, String s) {
		//ȥַstrsͷֻȥһΡ
		if(str.startsWith(s)) str = str.substring(s.length()); //sͷȥ
		return str;
	}

	/**
	 * ȥַ
	 * @param str Ҫַ
	 * @param s ҪȥĽβַ
	 * @return strȥβsַ
	 */
	public static String delStrAfter(String str, String s) {
		//ȥַstrsβֻȥһΡ
		if(str.endsWith(s)) str = str.substring(0, str.length() - s.length()); //sβȥ
		return str;
	}
}
